Index: branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 492)
+++ branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 494)
@@ -4567,7 +4687,4 @@
 
         xram_rsp_to_cc_send_fifo_srcid    = entry.owner.srcid;
-#if L1_MULTI_CACHE
-        xram_rsp_to_cc_send_fifo_cache_id = entry.owner.cache_id;
-#endif
         xram_rsp_to_cc_send_fifo_inst  = entry.owner.inst;
         xram_rsp_to_cc_send_fifo_put   = true;
@@ -4613,7 +4730,4 @@
       HeapEntry last_entry;
       last_entry.owner.srcid    = 0;
-#if L1_MULTI_CACHE
-      last_entry.owner.cache_id = 0;
-#endif
       last_entry.owner.inst     = false;
       if(m_heap.is_full())
@@ -4639,5 +4753,5 @@
       break;
     }
-    // ///////////////////////
+    //////////////////////////
     case XRAM_RSP_ERROR_ERASE:  // erase TRT entry in case of error
     {
@@ -4692,54 +4806,41 @@
   ////////////////////////////////////////////////////////////////////////////////////
 
+//std::cout << std::endl << "cleanup_fsm" << std::endl;
+
   switch(r_cleanup_fsm.read())
   {
-    //////////////////
-    case CLEANUP_IDLE:     // Get first DSPIN flit of the CLEANUP command
-    {
-      if(not m_cc_receive_to_cleanup_fifo.rok()) break;
-
-      uint64_t flit = m_cc_receive_to_cleanup_fifo.read();
-      uint32_t srcid =
-        DspinDhccpParam::dspin_get(
-            flit,
-            DspinDhccpParam::CLEANUP_SRCID);
-
-      uint8_t type =
-        DspinDhccpParam::dspin_get(
-            flit,
-            DspinDhccpParam::P2M_TYPE);
-
-      r_cleanup_way_index =
-        DspinDhccpParam::dspin_get(
-            flit,
-            DspinDhccpParam::CLEANUP_WAY_INDEX);
-
-      r_cleanup_nline =
-        DspinDhccpParam::dspin_get(
-            flit,
-            DspinDhccpParam::CLEANUP_NLINE_MSB) << 32;
-
-      /*ODCCP*/ // Cleanup on no coherent line if 1
-      r_cleanup_ncc = 
-        DspinDhccpParam::dspin_get(
-            flit, 
-            DspinDhccpParam::CLEANUP_NCC);
-
-      r_cleanup_inst  = (type == DspinDhccpParam::TYPE_CLEANUP_INST);
-      r_cleanup_srcid = srcid;
-
-      if(srcid >= m_initiators)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_IDLE state"  << std::endl
-            << "illegal srcid for cleanup request" << std::endl;
-
-        exit(0);
-      }
-
-      m_cpt_cleanup++;
-      cc_receive_to_cleanup_fifo_get = true;
-      r_cleanup_fsm                  = CLEANUP_GET_NLINE;
+      //////////////////
+      case CLEANUP_IDLE:     // Get first DSPIN flit of the CLEANUP command
+      {
+          if(not m_cc_receive_to_cleanup_fifo.rok()) break;
+
+          uint64_t flit = m_cc_receive_to_cleanup_fifo.read();
+          uint32_t srcid = DspinDhccpParam::dspin_get( flit, 
+                           DspinDhccpParam::CLEANUP_SRCID);
+
+          uint8_t type = DspinDhccpParam::dspin_get( flit, 
+                         DspinDhccpParam::P2M_TYPE);
+
+          r_cleanup_way_index = DspinDhccpParam::dspin_get( flit, 
+                                DspinDhccpParam::CLEANUP_WAY_INDEX);
+
+          r_cleanup_nline = DspinDhccpParam::dspin_get( flit, 
+                            DspinDhccpParam::CLEANUP_NLINE_MSB) << 32;
+
+          /*ODCCP*/ // Cleanup on no coherent line if 1
+          r_cleanup_ncc = 
+            DspinDhccpParam::dspin_get(
+                flit, 
+                DspinDhccpParam::CLEANUP_NCC);
+
+          r_cleanup_inst  = (type == DspinDhccpParam::TYPE_CLEANUP_INST);
+          r_cleanup_srcid = srcid;
+
+          assert( (srcid < m_initiators) and
+          "MEMC ERROR in CLEANUP_IDLE state : illegal SRCID value");
+
+          m_cpt_cleanup++;
+          cc_receive_to_cleanup_fifo_get = true;
+          r_cleanup_fsm                  = CLEANUP_GET_NLINE;
 
 #if DEBUG_MEMC_CLEANUP
@@ -4747,20 +4848,23 @@
 std::cout << "  <MEMC "         << name()
           << " CLEANUP_IDLE> Cleanup request:" << std::hex
-          << " / owner_id = "   << srcid
+          << " owner_id = "   << srcid
           << " / owner_ins = "  << (type == DspinDhccpParam::TYPE_CLEANUP_INST) << std::endl;
 #endif
-      break;
-    }
-
-    ///////////////////////
-    case CLEANUP_GET_NLINE:  // GET second DSPIN flit of the cleanup command
-    {
-      if(not m_cc_receive_to_cleanup_fifo.rok()) break;
+          break;
+      }
+      ///////////////////////
+      case CLEANUP_GET_NLINE:  // GET second DSPIN flit of the cleanup command
+      {
+          if(not m_cc_receive_to_cleanup_fifo.rok()) break;
+
+          uint64_t flit = m_cc_receive_to_cleanup_fifo.read();
       
 
-      uint64_t flit = m_cc_receive_to_cleanup_fifo.read();
-
-      addr_t nline = r_cleanup_nline.read() |
-        DspinDhccpParam::dspin_get(flit, DspinDhccpParam::CLEANUP_NLINE_LSB);
+          addr_t nline = r_cleanup_nline.read() |
+              DspinDhccpParam::dspin_get(flit, DspinDhccpParam::CLEANUP_NLINE_LSB);
+
+          cc_receive_to_cleanup_fifo_get = true;
+          r_cleanup_nline                = nline;
+          r_cleanup_fsm                  = CLEANUP_DIR_REQ;
       
       bool eop = DspinDhccpParam::dspin_get(flit, DspinDhccpParam::P2M_EOP);
@@ -4789,7 +4893,7 @@
           << " / address = " << std::hex << nline * m_words * 4 << std::endl;
 #endif
-      break;
-    }
-
+          break;
+      }
+      /////////////////////
     /*ODCCP*/ // We save the cleanup's data into a buffer
     case CLEANUP_GET_DATA :
@@ -4818,9 +4922,7 @@
     case CLEANUP_DIR_REQ:   // Get the lock to the directory
     {
-      m_cpt_cleanup_fsm_dir_lock++;
       // Get the lock to the directory
       if(r_alloc_dir_fsm.read() != ALLOC_DIR_CLEANUP) break;
-
-      r_cleanup_fsm = CLEANUP_DIR_LOCK;
+          r_cleanup_fsm = CLEANUP_DIR_LOCK;
 
 #if DEBUG_MEMC_CLEANUP
@@ -4828,424 +4930,257 @@
 std::cout << "  <MEMC " << name() << " CLEANUP_DIR_REQ> Requesting DIR lock" << std::endl;
 #endif
-
-      m_cpt_cleanup_fsm_n_dir_lock++;
+          break;
+      }
+      //////////////////////
+      case CLEANUP_DIR_LOCK:    // test directory status
+      {
+          assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CLEANUP) and
+          "MEMC ERROR in CLEANUP_DIR_LOCK: bad DIR allocation");
+
+          // Read the directory
+          size_t way = 0;
+          addr_t cleanup_address = r_cleanup_nline.read() * m_words * 4;
+          DirectoryEntry entry   = m_cache_directory.read(cleanup_address , way);
+          r_cleanup_is_cnt       = entry.is_cnt;
+          r_cleanup_dirty        = entry.dirty;
+          r_cleanup_tag          = entry.tag;
+          r_cleanup_lock         = entry.lock;
+          r_cleanup_way          = way;
+          r_cleanup_count        = entry.count;
+          r_cleanup_ptr          = entry.ptr;
+          r_cleanup_copy         = entry.owner.srcid;
+          r_cleanup_copy_inst    = entry.owner.inst;
+          if(entry.valid)      // hit : the copy must be cleared
+          {
+              assert( (entry.count > 0) and
+              "MEMC ERROR in CLEANUP_DIR_LOCK state, CLEANUP on valid entry with no copies");
+
+              if((entry.count == 1) or (entry.is_cnt))   // no access to the heap
+              {
+                  r_cleanup_fsm = CLEANUP_DIR_WRITE;
+              }
+              else                                       // access to the heap
+              {
+                  r_cleanup_fsm = CLEANUP_HEAP_REQ;
+              }
+          }
+          else                // miss : check IVT for a pending inval
+          {
+              r_cleanup_fsm = CLEANUP_IVT_LOCK;
+          }
+
+#if DEBUG_MEMC_CLEANUP
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CLEANUP_DIR_LOCK> Test directory status: "
+          << std::hex << " address = " << cleanup_address
+          << " / hit = "        << entry.valid
+          << " / dir_id = "     << entry.owner.srcid
+          << " / dir_ins = "    << entry.owner.inst
+          << " / search_id = "  << r_cleanup_srcid.read()
+          << " / search_ins = " << r_cleanup_inst.read()
+          << " / count = "      << entry.count
+          << " / is_cnt = "     << entry.is_cnt << std::endl;
+#endif
+          break;
+      }
+      ///////////////////////
+      case CLEANUP_DIR_WRITE:      // Update the directory entry without heap access
+      {
+          assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CLEANUP) and
+          "MEMC ERROR in CLEANUP_DIR_LOCK: bad DIR allocation");
+
+          size_t way         = r_cleanup_way.read();
+          size_t set         = m_y[(addr_t)(r_cleanup_nline.read()*m_words*4)];
+          bool   match_srcid = (r_cleanup_copy.read() == r_cleanup_srcid.read());
+          bool   match_inst  = (r_cleanup_copy_inst.read() == r_cleanup_inst.read());
+          bool   match       = match_srcid and match_inst;
+
+          assert( (r_cleanup_is_cnt.read() or match) and
+          "MEMC ERROR in CLEANUP_DIR_LOCK: illegal CLEANUP on valid entry");
+
+          // update the cache directory (for the copies)
+          DirectoryEntry entry;
+          entry.valid       = true;
+          entry.is_cnt      = r_cleanup_is_cnt.read();
+          entry.dirty       = r_cleanup_dirty.read() or r_cleanup_contains_data.read();
+          entry.tag         = r_cleanup_tag.read();
+          entry.lock        = r_cleanup_lock.read();
+          entry.ptr         = r_cleanup_ptr.read();
+          entry.count       = r_cleanup_count.read() - 1;
+          entry.owner.srcid = 0;
+          entry.owner.inst  = 0;
+          /*ODCCP*/ // if cleanup contains data we update the cache data
+          if (r_cleanup_contains_data.read())
+          {
+            for (size_t word = 0; word < m_words; word ++)
+            {
+              m_cache_data.write(way, set, word, r_cleanup_data[word].read(), 0xF);
+            }
+          }
+
+
+          m_cache_directory.write(set, way, entry);
+
+          r_cleanup_fsm = CLEANUP_SEND_CLACK;
+
+#if DEBUG_MEMC_CLEANUP
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CLEANUP_DIR_WRITE> Update directory:"
+          << std::hex << " address = "   << r_cleanup_nline.read() * m_words * 4
+          << " / dir_id = "  << entry.owner.srcid
+          << " / dir_ins = " << entry.owner.inst
+          << " / count = "   << entry.count
+          << " / is_cnt = "  << entry.is_cnt << std::endl;
+#endif
 
       break;
     }
 
-    //////////////////////
-    case CLEANUP_DIR_LOCK:
-    {
-      // test directory status
-      if(r_alloc_dir_fsm.read() != ALLOC_DIR_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_DIR_LOCK state"
-            << " bad DIR allocation" << std::endl;
-
-        exit(0);
-      }
-      // Read the directory
-      size_t way = 0;
-      addr_t cleanup_address = r_cleanup_nline.read() * m_words * 4;
-
-      DirectoryEntry entry   = m_cache_directory.read(cleanup_address , way);
-      r_cleanup_is_cnt       = entry.is_cnt;
-      r_cleanup_dirty        = entry.dirty;
-      r_cleanup_tag          = entry.tag;
-      r_cleanup_lock         = entry.lock;
-      r_cleanup_way          = way;
-      r_cleanup_count        = entry.count;
-      r_cleanup_ptr          = entry.ptr;
-      r_cleanup_copy         = entry.owner.srcid;
-      r_cleanup_copy_inst    = entry.owner.inst;
-#if L1_MULTI_CACHE
-      r_cleanup_copy_cache   = entry.owner.cache_id;
-#endif
-
-      if(entry.valid)      // hit : the copy must be cleared
-      {
-        if(entry.count < 1)
-        {
-          std::cout << "assert on line " << std::hex <<r_cleanup_nline.read() << " | at cycle " << std::dec <<m_cpt_cycles << std::endl;
-          std::cout << "cleanup with data ? " << r_cleanup_contains_data.read() << " | at cycle " << m_cpt_cycles << std::endl;
-          std::cout << "cleanup_address = " << std::hex << (r_cleanup_nline.read()*m_words*4) << std::dec << std::endl;
-          std::cout << "srcid = " << r_cleanup_srcid.read() << std::endl;
-          std::cout << "inst = " << r_cleanup_inst.read() << std::endl;
-          std::cout << "inst = " << r_cleanup_inst.read() << std::endl;
-        }
-        assert(
-            (entry.count > 0) and
-            "VCI MEM CACHE ERROR: "
-            "In CLEANUP_DIR_LOCK, CLEANUP command on a valid entry "
-            "with no copies");
-
-        // no access to the heap
-        if((entry.count == 1) or (entry.is_cnt))
-        {
-          r_cleanup_fsm = CLEANUP_DIR_WRITE;
-        }
-        // access to the heap
-        else
-        {
-          r_cleanup_fsm = CLEANUP_HEAP_REQ;
-        }
-      }
-      else                // miss : check UPT for a pending invalidation transaction
-      {
-        r_cleanup_fsm = CLEANUP_IVT_LOCK;
-      }
+      //////////////////////
+      case CLEANUP_HEAP_REQ:         // get the lock to the HEAP directory
+      {
+          if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP) break;
+
+          r_cleanup_fsm = CLEANUP_HEAP_LOCK;
 
 #if DEBUG_MEMC_CLEANUP
-      if(m_debug)
-      {
-        std::cout
-            << "  <MEMC " << name()
-            << " CLEANUP_DIR_LOCK> Test directory status: "
-            << std::hex
-            << " line = "         << cleanup_address
-            << " / hit = "        << entry.valid
-            << " / dir_id = "     << entry.owner.srcid
-            << " / dir_ins = "    << entry.owner.inst
-            << " / search_id = "  << r_cleanup_srcid.read()
-            << " / search_ins = " << r_cleanup_inst.read()
-            << " / count = "      << entry.count
-            << " / is_cnt = "     << entry.is_cnt
-            << std::endl;
-      }
-#endif
-      break;
-    }
-
-    ///////////////////////
-    case CLEANUP_DIR_WRITE:
-    {
-      // Update the directory entry without heap access
-      if(r_alloc_dir_fsm.read() != ALLOC_DIR_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_DIR_WRITE state"
-            << " bad DIR allocation" << std::endl;
-
-        exit(0);
-      }
-
-      size_t way         = r_cleanup_way.read();
-      size_t set         = m_y[(addr_t)(r_cleanup_nline.read()*m_words*4)];
-      bool   match_srcid = (r_cleanup_copy.read() == r_cleanup_srcid.read());
-
-#if L1_MULTI_CACHE
-      match_srcid       &= (r_cleanup_copy_cache.read() == r_cleanup_pktid.read());
-#endif
-
-      bool   match_inst  = (r_cleanup_copy_inst.read() == r_cleanup_inst.read());
-      bool   match       = match_srcid and match_inst;
-
-      if(not r_cleanup_is_cnt.read() and not match)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR : Cleanup request on a valid"
-            << "entry using linked list mode with no corresponding"
-            << "directory or heap entry"
-            << std::endl;
-
-        exit(1);
-      }
-
-      // update the cache directory (for the copies)
-      DirectoryEntry entry;
-      entry.valid       = true;
-      entry.is_cnt      = r_cleanup_is_cnt.read();
-      entry.dirty       = r_cleanup_dirty.read() or r_cleanup_contains_data.read();
-      entry.tag         = r_cleanup_tag.read();
-      entry.lock        = r_cleanup_lock.read();
-      entry.ptr         = r_cleanup_ptr.read();
-      entry.count       = r_cleanup_count.read() - 1;
-      entry.owner.srcid = 0;
-      entry.owner.inst  = 0;
-
-#if L1_MULTI_CACHE
-      entry.owner.cache_id = 0;
-#endif
-      /*ODCCP*/ // if cleanup contains data we update the cache data
-      if (r_cleanup_contains_data.read())
-      {
-        for (size_t word = 0; word < m_words; word ++)
-        {
-          m_cache_data.write(way, set, word, r_cleanup_data[word].read(), 0xF);
-        }
-      }
-
-
-      m_cache_directory.write(set, way, entry);
-
-      r_cleanup_fsm = CLEANUP_SEND_CLACK;
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CLEANUP_HEAP_REQ> HEAP lock acquired " << std::endl;
+#endif
+          break;
+      }
+      //////////////////////
+      case CLEANUP_HEAP_LOCK:      // two cases are handled in this state :
+                                 // 1. the matching copy is directly in the directory
+                                 // 2. the matching copy is the first copy in the heap
+      {
+          assert( (r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP) and
+          "MEMC ERROR in CLEANUP_HEAP_LOCK state: bad HEAP allocation");
+
+          size_t way            = r_cleanup_way.read();
+          size_t set            = m_y[(addr_t)(r_cleanup_nline.read() *m_words*4)];
+
+          HeapEntry heap_entry  = m_heap.read(r_cleanup_ptr.read());
+          bool last             = (heap_entry.next == r_cleanup_ptr.read());
+
+          // match_dir computation
+          bool match_dir_srcid  = (r_cleanup_copy.read()      == r_cleanup_srcid.read());
+          bool match_dir_inst   = (r_cleanup_copy_inst.read() == r_cleanup_inst.read());
+          bool match_dir        = match_dir_srcid  and match_dir_inst;
+
+          // match_heap computation
+          bool match_heap_srcid = (heap_entry.owner.srcid == r_cleanup_srcid.read());
+          bool match_heap_inst  = (heap_entry.owner.inst  == r_cleanup_inst.read());
+          bool match_heap       = match_heap_srcid and match_heap_inst;
+
+          r_cleanup_prev_ptr    = r_cleanup_ptr.read();
+          r_cleanup_prev_srcid  = heap_entry.owner.srcid;
+          r_cleanup_prev_inst   = heap_entry.owner.inst;
+
+          assert( (not last or match_dir or match_heap) and
+          "MEMC ERROR in CLEANUP_HEAP_LOCK state: hit but no copy found");
+
+          assert( (not match_dir or not match_heap) and
+          "MEMC ERROR in CLEANUP_HEAP_LOCK state: two matching copies found");
+
+          DirectoryEntry dir_entry;
+          dir_entry.valid          = true;
+          dir_entry.is_cnt         = r_cleanup_is_cnt.read();
+          dir_entry.dirty          = r_cleanup_dirty.read();
+          dir_entry.tag            = r_cleanup_tag.read();
+          dir_entry.lock           = r_cleanup_lock.read();
+          dir_entry.count          = r_cleanup_count.read()-1;
+
+          // the matching copy is registered in the directory and
+          // it must be replaced by the first copy registered in
+          // the heap. The corresponding entry must be freed
+          if(match_dir)
+          {
+              dir_entry.ptr            = heap_entry.next;
+              dir_entry.owner.srcid    = heap_entry.owner.srcid;
+              dir_entry.owner.inst     = heap_entry.owner.inst;
+              r_cleanup_next_ptr       = r_cleanup_ptr.read();
+              r_cleanup_fsm            = CLEANUP_HEAP_FREE;
+          }
+
+          // the matching copy is the first copy in the heap
+          // It must be freed and the copy registered in directory
+          // must point to the next copy in heap
+          else if(match_heap)
+          {
+              dir_entry.ptr            = heap_entry.next;
+              dir_entry.owner.srcid    = r_cleanup_copy.read();
+              dir_entry.owner.inst     = r_cleanup_copy_inst.read();
+              r_cleanup_next_ptr       = r_cleanup_ptr.read();
+              r_cleanup_fsm            = CLEANUP_HEAP_FREE;
+          }
+
+          // The matching copy is in the heap, but is not the first copy
+          // The directory entry must be modified to decrement count
+          else
+          {
+              dir_entry.ptr            = r_cleanup_ptr.read();
+              dir_entry.owner.srcid    = r_cleanup_copy.read();
+              dir_entry.owner.inst     = r_cleanup_copy_inst.read();
+              r_cleanup_next_ptr       = heap_entry.next;
+              r_cleanup_fsm            = CLEANUP_HEAP_SEARCH;
+          }
+
+          m_cache_directory.write(set,way,dir_entry);
 
 #if DEBUG_MEMC_CLEANUP
-      if(m_debug)
-      {
-        std::cout
-            << "  <MEMC " << name()
-            << " CLEANUP_DIR_WRITE> Update directory:"
-            << std::hex
-            << " address = "   << r_cleanup_nline.read() * m_words * 4
-            << " / dir_id = "  << entry.owner.srcid
-            << " / dir_ins = " << entry.owner.inst
-            << " / count = "   << entry.count
-            << " / is_cnt = "  << entry.is_cnt
-            << std::endl;
-      }
-#endif
-
-      break;
-    }
-
-    //////////////////////
-    case CLEANUP_HEAP_REQ:
-    {
-      // get the lock to the HEAP directory
-      m_cpt_cleanup_fsm_heap_lock++;
-      if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP) break;
-
-      r_cleanup_fsm = CLEANUP_HEAP_LOCK;
+if(m_debug)
+std::cout << "  <MEMC " << name()
+          << " CLEANUP_HEAP_LOCK> Checks matching:"
+          << " address = "      << r_cleanup_nline.read() * m_words * 4
+          << " / dir_id = "     << r_cleanup_copy.read()
+          << " / dir_ins = "    << r_cleanup_copy_inst.read()
+          << " / heap_id = "    << heap_entry.owner.srcid
+          << " / heap_ins = "   << heap_entry.owner.inst
+          << " / search_id = "  << r_cleanup_srcid.read()
+          << " / search_ins = " << r_cleanup_inst.read() << std::endl;
+#endif
+          break;
+      }
+      ////////////////////////
+      case CLEANUP_HEAP_SEARCH:     // This state is handling the case where the copy
+                                    // is in the heap, but not the first in linked list
+      {
+          assert( (r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP) and
+          "MEMC ERROR in CLEANUP_HEAP_LOCK state: bad HEAP allocation");
+
+          HeapEntry heap_entry  = m_heap.read(r_cleanup_next_ptr.read());
+
+          bool last             = (heap_entry.next        == r_cleanup_next_ptr.read());
+          bool match_heap_srcid = (heap_entry.owner.srcid == r_cleanup_srcid.read());
+          bool match_heap_inst  = (heap_entry.owner.inst  == r_cleanup_inst.read());
+          bool match_heap       = match_heap_srcid and match_heap_inst;
+
+          assert( (not last or match_heap) and
+          "MEMC ERROR in CLEANUP_HEAP_SEARCH state: no copy found");
+
+          // the matching copy must be removed
+          if(match_heap)
+          {
+              // re-use ressources
+              r_cleanup_ptr = heap_entry.next;
+              r_cleanup_fsm = CLEANUP_HEAP_CLEAN;
+          }
+          // test the next in the linked list
+          else
+          {
+              r_cleanup_prev_ptr      = r_cleanup_next_ptr.read();
+              r_cleanup_prev_srcid    = heap_entry.owner.srcid;
+              r_cleanup_prev_inst     = heap_entry.owner.inst;
+              r_cleanup_next_ptr      = heap_entry.next;
+              r_cleanup_fsm           = CLEANUP_HEAP_SEARCH;
+          }
 
 #if DEBUG_MEMC_CLEANUP
-      if(m_debug)
-      {
-        std::cout
-            << "  <MEMC " << name()
-            << " CLEANUP_HEAP_REQ> HEAP lock acquired "
-            << std::endl;
-      }
-#endif
-      m_cpt_cleanup_fsm_n_heap_lock++;
-      break;
-    }
-
-    //////////////////////
-    case CLEANUP_HEAP_LOCK:
-    {
-      // two cases are handled in this state :
-      // 1. the matching copy is directly in the directory
-      // 2. the matching copy is the first copy in the heap
-      if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_LOCK state"
-            << " bad HEAP allocation" << std::endl;
-
-        exit(0);
-      }
-
-      size_t way            = r_cleanup_way.read();
-      size_t set            = m_y[(addr_t)(r_cleanup_nline.read() *m_words*4)];
-
-      HeapEntry heap_entry  = m_heap.read(r_cleanup_ptr.read());
-      bool last             = (heap_entry.next == r_cleanup_ptr.read());
-
-      // match_dir computation
-      bool match_dir_srcid  = (r_cleanup_copy.read()      == r_cleanup_srcid.read());
-      bool match_dir_inst   = (r_cleanup_copy_inst.read() == r_cleanup_inst.read());
-      bool match_dir        = match_dir_srcid  and match_dir_inst;
-
-      // match_heap computation
-      bool match_heap_srcid = (heap_entry.owner.srcid == r_cleanup_srcid.read());
-      bool match_heap_inst  = (heap_entry.owner.inst  == r_cleanup_inst.read());
-      bool match_heap       = match_heap_srcid and match_heap_inst;
-
-      r_cleanup_prev_ptr    = r_cleanup_ptr.read();
-      r_cleanup_prev_srcid  = heap_entry.owner.srcid;
-      r_cleanup_prev_inst   = heap_entry.owner.inst;
-
-#if L1_MULTI_CACHE
-      match_dir  = match_dir  and(r_cleanup_copy_cache.read() == r_cleanup_pktid.read());
-      match_heap = match_heap and(heap_entry.owner.cache_id   == r_cleanup_pktid.read());
-      r_cleanup_prev_cache_id = heap_entry.owner.cache_id;
-#endif
-
-      if(not match_dir and not match_heap and last)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_LOCK state"
-            << " hit but copy not found"
-            << std::endl;
-/**/
-        std::cout
-          << "r_cleanup_srcid = " << r_cleanup_srcid.read()
-          << " / r_cleanup_inst = " << r_cleanup_inst.read() << std::endl
-          << "r_cleanup_copy = " << r_cleanup_copy.read()
-          << " / r_cleanup_copy_inst = " << r_cleanup_copy_inst.read() << std::endl
-          << "heap_entry.owner.srcid = " << heap_entry.owner.srcid
-          << " / heap_entry.owner.inst = " << heap_entry.owner.inst << std::endl;
-/**/
-        exit(0);
-      }
-
-      if(match_dir and match_heap)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_LOCK state"
-            << " two copies matching the cleanup owner id"
-            << std::endl;
-/**/
-        std::cout
-          << "r_cleanup_srcid = " << r_cleanup_srcid.read()
-          << " / r_cleanup_inst = " << r_cleanup_inst.read() << std::endl
-          << "r_cleanup_copy = " << r_cleanup_copy.read()
-          << " / r_cleanup_copy_inst = " << r_cleanup_copy_inst.read() << std::endl
-          << "heap_entry.owner.srcid = " << heap_entry.owner.srcid
-          << " / heap_entry.owner.inst = " << heap_entry.owner.inst << std::endl
-          << " / addr = " << std::hex << (r_cleanup_nline.read() *m_words*4) << std::dec << std::endl;
-/**/
-
-        exit(0);
-      }
-
-      DirectoryEntry dir_entry;
-      dir_entry.valid          = true;
-      dir_entry.is_cnt         = r_cleanup_is_cnt.read();
-      dir_entry.dirty          = r_cleanup_dirty.read();
-      dir_entry.tag            = r_cleanup_tag.read();
-      dir_entry.lock           = r_cleanup_lock.read();
-      dir_entry.count          = r_cleanup_count.read()-1;
-
-      // the matching copy is registered in the directory and
-      // it must be replaced by the first copy registered in
-      // the heap. The corresponding entry must be freed
-      if(match_dir)
-      {
-        dir_entry.ptr            = heap_entry.next;
-        dir_entry.owner.srcid    = heap_entry.owner.srcid;
-        dir_entry.owner.inst     = heap_entry.owner.inst;
-
-#if L1_MULTI_CACHE
-        dir_entry.owner.cache_id = heap_entry.owner.cache_id;
-#endif
-
-        r_cleanup_next_ptr       = r_cleanup_ptr.read();
-        r_cleanup_fsm            = CLEANUP_HEAP_FREE;
-      }
-
-      // the matching copy is the first copy in the heap
-      // It must be freed and the copy registered in directory
-      // must point to the next copy in heap
-      else if(match_heap)
-      {
-        dir_entry.ptr            = heap_entry.next;
-        dir_entry.owner.srcid    = r_cleanup_copy.read();
-        dir_entry.owner.inst     = r_cleanup_copy_inst.read();
-
-#if L1_MULTI_CACHE
-        dir_entry.owner.cache_id = r_cleanup_copy_cache.read();
-#endif
-
-        r_cleanup_next_ptr       = r_cleanup_ptr.read();
-        r_cleanup_fsm            = CLEANUP_HEAP_FREE;
-      }
-
-      // The matching copy is in the heap, but is not the first copy
-      // The directory entry must be modified to decrement count
-      else
-      {
-        dir_entry.ptr            = r_cleanup_ptr.read();
-        dir_entry.owner.srcid    = r_cleanup_copy.read();
-        dir_entry.owner.inst     = r_cleanup_copy_inst.read();
-
-#if L1_MULTI_CACHE
-        dir_entry.owner.cache_id = r_cleanup_copy_cache.read();
-#endif
-
-        r_cleanup_next_ptr       = heap_entry.next;
-        r_cleanup_fsm            = CLEANUP_HEAP_SEARCH;
-      }
-
-      m_cache_directory.write(set,way,dir_entry);
-
-#if DEBUG_MEMC_CLEANUP
-      if(m_debug)
-      {
-        std::cout
-            << "  <MEMC " << name()
-            << " CLEANUP_HEAP_LOCK> Checks matching:"
-            << " address = "      << r_cleanup_nline.read() * m_words * 4
-            << " / dir_id = "     << r_cleanup_copy.read()
-            << " / dir_ins = "    << r_cleanup_copy_inst.read()
-            << " / heap_id = "    << heap_entry.owner.srcid
-            << " / heap_ins = "   << heap_entry.owner.inst
-            << " / search_id = "  << r_cleanup_srcid.read()
-            << " / search_ins = " << r_cleanup_inst.read()
-            << std::endl;
-      }
-#endif
-      break;
-    }
-
-    ////////////////////////
-    case CLEANUP_HEAP_SEARCH:
-    {
-      // This state is handling the case where the copy
-      // is in the heap, but is not the first in the linked list
-      if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_SEARCH state"
-            << " bad HEAP allocation" << std::endl;
-
-        exit(0);
-      }
-
-      HeapEntry heap_entry  = m_heap.read(r_cleanup_next_ptr.read());
-
-      bool last             = (heap_entry.next        == r_cleanup_next_ptr.read());
-      bool match_heap_srcid = (heap_entry.owner.srcid == r_cleanup_srcid.read());
-      bool match_heap_inst  = (heap_entry.owner.inst  == r_cleanup_inst.read());
-      bool match_heap       = match_heap_srcid and match_heap_inst;
-
-#if L1_MULTI_CACHE
-      match_heap = match_heap and(heap_entry.owner.cache_id == r_cleanup_pktid.read());
-#endif
-
-      if(not match_heap and last)
-      {
-        std::cout
-            << "VCI_MEM_CACHE_ERROR " << name()
-            << " CLEANUP_HEAP_SEARCH state"
-            << " cleanup on valid line but copy not found"
-            << std::endl;
-
-        exit(0);
-      }
-
-      // the matching copy must be removed
-      if(match_heap)
-      {
-        // re-use ressources
-        r_cleanup_ptr = heap_entry.next;
-        r_cleanup_fsm = CLEANUP_HEAP_CLEAN;
-      }
-      // test the next in the linked list
-      else
-      {
-        r_cleanup_prev_ptr      = r_cleanup_next_ptr.read();
-        r_cleanup_prev_srcid    = heap_entry.owner.srcid;
-        r_cleanup_prev_inst     = heap_entry.owner.inst;
-        r_cleanup_next_ptr      = heap_entry.next;
-
-        r_cleanup_fsm           = CLEANUP_HEAP_SEARCH;
-
-#if L1_MULTI_CACHE
-        r_cleanup_prev_cache_id = heap_entry.owner.cache_id;
-#endif
-      }
-
-#if DEBUG_MEMC_CLEANUP
-      if(m_debug)
-      {
+if(m_debug)
+{
         if(not match_heap)
         {
@@ -5262,5 +5197,4 @@
               << std::endl;
         }
-
         std::cout
             << " address = "      << r_cleanup_nline.read() * m_words * 4
